<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>MenuComponent</title>
    <script type="module">
        import { LitElement, css, html } from 'https://unpkg.com/lit-element/lit-element.js?module';

        class VerticalMenu extends LitElement
        {
            static get properties() 
            { 
                return {
                    url: {
                        type: String, reflect: true},

                currentTimeString: {type: String, reflect: true},
                isActive: {type: Boolean},
            };}

            constructor()
            {
                super();
                this.url = "init";
                console.log(this.url);
            }

            connectedCallback()
            {
                super.connectedCallback();
                console.log(this.url);
            }

            static get styles() 
            {
                return css`
                    div { color: white; }
                    ul {
                        list-style-type: none;
                        margin: 0;
                        padding: 0;
                        overflow: hidden;
                        background-color: #333333;
                    }

                    div.button {
                        display: inline-block;
                        color: white;
                        text-align: center;
                        padding: 16px;
                        text-decoration: none;
                    }                    

                    div.button:hover {
                        background-color: #111111;
                        cursor: pointer;
                    }
                `;
            }

            render()
            {
                return html`
                <div>
                    <ul>
                        <div  @click="${this.doStuff}" class="button">Erster</div>
                        <div class="button">Zweiter</div>
                        <div class="button">Dritter</div>
                    </ul>
                </div>
                `;
            }

            doStuff()
            {
                console.log("I do Stuff:");
                console.log(this.url);
            }
        }

        class HorizontalMenu extends VerticalMenu
        {
            constructor()
            {
                super();
            }

            static get styles() 
            {
                
                return [super.styles, css`
                    div.button {
                        display: block;
                    }
                `];
            }


            render()
            {
                return html`
                <div>
                    <ul>
                        <div class="button">Vierter</div>
                        <div class="button">Fünfter</div>
                        <div class="button">Sechster</div>
                    </ul>
                </div>
                `;
            }

        }
        
        customElements.define('vertical-menu', VerticalMenu)
        customElements.define('horizontal-menu', HorizontalMenu)
    </script>
</head>
<body>
    <vertical-menu url="Hi du Ei">
    </vertical-menu>    
    <horizontal-menu url="Hi du ZwEi">
    </horizontal-menu>
</body>
</html>